'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = createBabelTransform;

var _babelCore = require('babel-core');

function createBabelTransform() {
	return babelTransform;
}

function babelTransform(file, _, configuration) {
	const source = typeof file.buffer === 'string' ? file.buffer : file.buffer.toString('utf-8');
	file.buffer = (0, _babelCore.transform)(source, configuration.opts).code;

	if (configuration.recursive) {
		walk(file.dependencies, dependency => {
			const dependencySource = typeof dependency.buffer === 'string' ? dependency.buffer : dependency.buffer.toString('utf-8');
			dependency.buffer = (0, _babelCore.transform)(dependencySource, configuration.opts).code;
		});
	}

	return Promise.resolve(file);
}

function walk(dependencyTree, predecate) {
	flatten(dependencyTree).forEach(predecate);
}

function flatten(dependencyTree) {
	let vault = arguments.length <= 1 || arguments[1] === undefined ? [] : arguments[1];

	return Object.values(dependencyTree || {}).reduce((list, item) => {
		list.push(item);
		flatten(item.dependency, list);
		return list;
	}, vault);
}
module.exports = exports['default'];